<?php

namespace SabreSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConnectionType StructType
 * Meta information extracted from the WSDL
 * - documentation: To specify connection locations, preference level for each, min connection time, and whether location is specified for stopping or changing.
 * @subpackage Structs
 */
class ConnectionType extends AbstractStructBase
{
    /**
     * The ConnectionLocation
     * Meta information extracted from the WSDL
     * - maxOccurs: 9
     * @var \SabreSoap\StructType\ConnectionLocation[]
     */
    public $ConnectionLocation;
    /**
     * Constructor method for ConnectionType
     * @uses ConnectionType::setConnectionLocation()
     * @param \SabreSoap\StructType\ConnectionLocation[] $connectionLocation
     */
    public function __construct(array $connectionLocation = array())
    {
        $this
            ->setConnectionLocation($connectionLocation);
    }
    /**
     * Get ConnectionLocation value
     * @return \SabreSoap\StructType\ConnectionLocation[]|null
     */
    public function getConnectionLocation()
    {
        return $this->ConnectionLocation;
    }
    /**
     * Set ConnectionLocation value
     * @param \SabreSoap\StructType\ConnectionLocation[] $connectionLocation
     * @return \SabreSoap\StructType\ConnectionType
     */
    public function setConnectionLocation(array $connectionLocation = array())
    {
        $this->ConnectionLocation = $connectionLocation;
        return $this;
    }
    /**
     * Add item to ConnectionLocation value
     * @throws \InvalidArgumentException
     * @param \SabreSoap\StructType\ConnectionLocation $item
     * @return \SabreSoap\StructType\ConnectionType
     */
    public function addToConnectionLocation(\SabreSoap\StructType\ConnectionLocation $item)
    {
        $this->ConnectionLocation[] = $item;
        return $this;
    }
}
