<?php

namespace SabreSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DepartureDates StructType
 * Meta information extracted from the WSDL
 * - documentation: If both LengthOfStay (LengthOfStay, LengthOfStayRange) and Days (Day, DaysRange) tags are used, then as requested dates we are considering intersection between two groups of dates, first group is created by sum of dates specified in
 * Day and DaysRange tags, second group is created by LengthOfStay and LengthOfStayRange Example: outbound departing on 2014 Jan 20 and inbound with: LengthOfStayRange/@MinDays="1", LengthOfStayRange/@MaxDays="3", DaysRange/@FromDate="2014-01-22",
 * DaysRange/@ToDate="2014-01-24" after intersection gave us inbound departing range: [ 2014-01-22 ; 2014-01-23 ]
 * @subpackage Structs
 */
class DepartureDates extends AbstractStructBase
{
    /**
     * The Day
     * @var \SabreSoap\StructType\Day
     */
    public $Day;
    /**
     * The DaysRange
     * @var \SabreSoap\StructType\DaysRange
     */
    public $DaysRange;
    /**
     * The LengthOfStay
     * Meta information extracted from the WSDL
     * - choice: LengthOfStay | LengthOfStayRange | MultipleDatesGroup |  | LengthOfStay | LengthOfStayRange
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 1
     * @var \SabreSoap\StructType\LengthOfStay
     */
    public $LengthOfStay;
    /**
     * The LengthOfStayRange
     * Meta information extracted from the WSDL
     * - choice: LengthOfStay | LengthOfStayRange | MultipleDatesGroup |  | LengthOfStay | LengthOfStayRange
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 1
     * @var \SabreSoap\StructType\LengthOfStayRange
     */
    public $LengthOfStayRange;
    /**
     * Constructor method for DepartureDates
     * @uses DepartureDates::setDay()
     * @uses DepartureDates::setDaysRange()
     * @uses DepartureDates::setLengthOfStay()
     * @uses DepartureDates::setLengthOfStayRange()
     * @param \SabreSoap\StructType\Day $day
     * @param \SabreSoap\StructType\DaysRange $daysRange
     * @param \SabreSoap\StructType\LengthOfStay $lengthOfStay
     * @param \SabreSoap\StructType\LengthOfStayRange $lengthOfStayRange
     */
    public function __construct(\SabreSoap\StructType\Day $day = null, \SabreSoap\StructType\DaysRange $daysRange = null, \SabreSoap\StructType\LengthOfStay $lengthOfStay = null, \SabreSoap\StructType\LengthOfStayRange $lengthOfStayRange = null)
    {
        $this
            ->setDay($day)
            ->setDaysRange($daysRange)
            ->setLengthOfStay($lengthOfStay)
            ->setLengthOfStayRange($lengthOfStayRange);
    }
    /**
     * Get Day value
     * @return \SabreSoap\StructType\Day|null
     */
    public function getDay()
    {
        return $this->Day;
    }
    /**
     * Set Day value
     * @param \SabreSoap\StructType\Day $day
     * @return \SabreSoap\StructType\DepartureDates
     */
    public function setDay(\SabreSoap\StructType\Day $day = null)
    {
        $this->Day = $day;
        return $this;
    }
    /**
     * Get DaysRange value
     * @return \SabreSoap\StructType\DaysRange|null
     */
    public function getDaysRange()
    {
        return $this->DaysRange;
    }
    /**
     * Set DaysRange value
     * @param \SabreSoap\StructType\DaysRange $daysRange
     * @return \SabreSoap\StructType\DepartureDates
     */
    public function setDaysRange(\SabreSoap\StructType\DaysRange $daysRange = null)
    {
        $this->DaysRange = $daysRange;
        return $this;
    }
    /**
     * Get LengthOfStay value
     * @return \SabreSoap\StructType\LengthOfStay|null
     */
    public function getLengthOfStay()
    {
        return isset($this->LengthOfStay) ? $this->LengthOfStay : null;
    }
    /**
     * Set LengthOfStay value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param \SabreSoap\StructType\LengthOfStay $lengthOfStay
     * @return \SabreSoap\StructType\DepartureDates
     */
    public function setLengthOfStay(\SabreSoap\StructType\LengthOfStay $lengthOfStay = null)
    {
        if (is_null($lengthOfStay) || (is_array($lengthOfStay) && empty($lengthOfStay))) {
            unset($this->LengthOfStay);
        } else {
            $this->LengthOfStay = $lengthOfStay;
        }
        return $this;
    }
    /**
     * Get LengthOfStayRange value
     * @return \SabreSoap\StructType\LengthOfStayRange|null
     */
    public function getLengthOfStayRange()
    {
        return isset($this->LengthOfStayRange) ? $this->LengthOfStayRange : null;
    }
    /**
     * Set LengthOfStayRange value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @param \SabreSoap\StructType\LengthOfStayRange $lengthOfStayRange
     * @return \SabreSoap\StructType\DepartureDates
     */
    public function setLengthOfStayRange(\SabreSoap\StructType\LengthOfStayRange $lengthOfStayRange = null)
    {
        if (is_null($lengthOfStayRange) || (is_array($lengthOfStayRange) && empty($lengthOfStayRange))) {
            unset($this->LengthOfStayRange);
        } else {
            $this->LengthOfStayRange = $lengthOfStayRange;
        }
        return $this;
    }
}
