<?php

namespace SabreSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DiversitySwapper StructType
 * @subpackage Structs
 */
class DiversitySwapper extends AbstractStructBase
{
    /**
     * The WeighedPriceAmount
     * Meta information extracted from the WSDL
     * - documentation: (Penalty * price / 10) -- by which itins are sorted in Diversity Swapper
     * - use: required
     * @var float
     */
    public $WeighedPriceAmount;
    /**
     * Constructor method for DiversitySwapper
     * @uses DiversitySwapper::setWeighedPriceAmount()
     * @param float $weighedPriceAmount
     */
    public function __construct($weighedPriceAmount = null)
    {
        $this
            ->setWeighedPriceAmount($weighedPriceAmount);
    }
    /**
     * Get WeighedPriceAmount value
     * @return float
     */
    public function getWeighedPriceAmount()
    {
        return $this->WeighedPriceAmount;
    }
    /**
     * Set WeighedPriceAmount value
     * @param float $weighedPriceAmount
     * @return \SabreSoap\StructType\DiversitySwapper
     */
    public function setWeighedPriceAmount($weighedPriceAmount = null)
    {
        $this->WeighedPriceAmount = $weighedPriceAmount;
        return $this;
    }
}
