<?php

namespace SabreSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExchangeTravelPreferencesTPA_ExtensionsType StructType
 * @subpackage Structs
 */
class ExchangeTravelPreferencesTPA_ExtensionsType extends AbstractStructBase
{
    /**
     * The ExemptAllTaxes
     * @var \SabreSoap\StructType\ExemptAllTaxes
     */
    public $ExemptAllTaxes;
    /**
     * The ExemptAllTaxesAndFees
     * @var \SabreSoap\StructType\ExemptAllTaxesAndFees
     */
    public $ExemptAllTaxesAndFees;
    /**
     * The Taxes
     * @var \SabreSoap\StructType\Taxes
     */
    public $Taxes;
    /**
     * The ExemptTax
     * @var \SabreSoap\StructType\TaxCodeType
     */
    public $ExemptTax;
    /**
     * The SettlementMethod
     * Meta information extracted from the WSDL
     * - documentation: Overrides settlement method | Supported codes: BSP ARC TCH GEN (Generic TAT) RUT (Russian TAT) PRT (Philippines TAT) SAT (SATA) KRY (Killroy)
     * - base: xs:string
     * - minOccurs: 0
     * - pattern: [a-zA-Z0-9]{3}
     * @var string
     */
    public $SettlementMethod;
    /**
     * Constructor method for ExchangeTravelPreferencesTPA_ExtensionsType
     * @uses ExchangeTravelPreferencesTPA_ExtensionsType::setExemptAllTaxes()
     * @uses ExchangeTravelPreferencesTPA_ExtensionsType::setExemptAllTaxesAndFees()
     * @uses ExchangeTravelPreferencesTPA_ExtensionsType::setTaxes()
     * @uses ExchangeTravelPreferencesTPA_ExtensionsType::setExemptTax()
     * @uses ExchangeTravelPreferencesTPA_ExtensionsType::setSettlementMethod()
     * @param \SabreSoap\StructType\ExemptAllTaxes $exemptAllTaxes
     * @param \SabreSoap\StructType\ExemptAllTaxesAndFees $exemptAllTaxesAndFees
     * @param \SabreSoap\StructType\Taxes $taxes
     * @param \SabreSoap\StructType\TaxCodeType $exemptTax
     * @param string $settlementMethod
     */
    public function __construct(\SabreSoap\StructType\ExemptAllTaxes $exemptAllTaxes = null, \SabreSoap\StructType\ExemptAllTaxesAndFees $exemptAllTaxesAndFees = null, \SabreSoap\StructType\Taxes $taxes = null, \SabreSoap\StructType\TaxCodeType $exemptTax = null, $settlementMethod = null)
    {
        $this
            ->setExemptAllTaxes($exemptAllTaxes)
            ->setExemptAllTaxesAndFees($exemptAllTaxesAndFees)
            ->setTaxes($taxes)
            ->setExemptTax($exemptTax)
            ->setSettlementMethod($settlementMethod);
    }
    /**
     * Get ExemptAllTaxes value
     * @return \SabreSoap\StructType\ExemptAllTaxes|null
     */
    public function getExemptAllTaxes()
    {
        return $this->ExemptAllTaxes;
    }
    /**
     * Set ExemptAllTaxes value
     * @param \SabreSoap\StructType\ExemptAllTaxes $exemptAllTaxes
     * @return \SabreSoap\StructType\ExchangeTravelPreferencesTPA_ExtensionsType
     */
    public function setExemptAllTaxes(\SabreSoap\StructType\ExemptAllTaxes $exemptAllTaxes = null)
    {
        $this->ExemptAllTaxes = $exemptAllTaxes;
        return $this;
    }
    /**
     * Get ExemptAllTaxesAndFees value
     * @return \SabreSoap\StructType\ExemptAllTaxesAndFees|null
     */
    public function getExemptAllTaxesAndFees()
    {
        return $this->ExemptAllTaxesAndFees;
    }
    /**
     * Set ExemptAllTaxesAndFees value
     * @param \SabreSoap\StructType\ExemptAllTaxesAndFees $exemptAllTaxesAndFees
     * @return \SabreSoap\StructType\ExchangeTravelPreferencesTPA_ExtensionsType
     */
    public function setExemptAllTaxesAndFees(\SabreSoap\StructType\ExemptAllTaxesAndFees $exemptAllTaxesAndFees = null)
    {
        $this->ExemptAllTaxesAndFees = $exemptAllTaxesAndFees;
        return $this;
    }
    /**
     * Get Taxes value
     * @return \SabreSoap\StructType\Taxes|null
     */
    public function getTaxes()
    {
        return $this->Taxes;
    }
    /**
     * Set Taxes value
     * @param \SabreSoap\StructType\Taxes $taxes
     * @return \SabreSoap\StructType\ExchangeTravelPreferencesTPA_ExtensionsType
     */
    public function setTaxes(\SabreSoap\StructType\Taxes $taxes = null)
    {
        $this->Taxes = $taxes;
        return $this;
    }
    /**
     * Get ExemptTax value
     * @return \SabreSoap\StructType\TaxCodeType|null
     */
    public function getExemptTax()
    {
        return $this->ExemptTax;
    }
    /**
     * Set ExemptTax value
     * @param \SabreSoap\StructType\TaxCodeType $exemptTax
     * @return \SabreSoap\StructType\ExchangeTravelPreferencesTPA_ExtensionsType
     */
    public function setExemptTax(\SabreSoap\StructType\TaxCodeType $exemptTax = null)
    {
        $this->ExemptTax = $exemptTax;
        return $this;
    }
    /**
     * Get SettlementMethod value
     * @return string|null
     */
    public function getSettlementMethod()
    {
        return $this->SettlementMethod;
    }
    /**
     * Set SettlementMethod value
     * @param string $settlementMethod
     * @return \SabreSoap\StructType\ExchangeTravelPreferencesTPA_ExtensionsType
     */
    public function setSettlementMethod($settlementMethod = null)
    {
        $this->SettlementMethod = $settlementMethod;
        return $this;
    }
}
