<?php

namespace SabreSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GoverningCarrierOverrideType StructType
 * @subpackage Structs
 */
class GoverningCarrierOverrideType extends AbstractStructBase
{
    /**
     * The AirlineCode
     * Meta information extracted from the WSDL
     * - documentation: Airline Carrier Code - override the GOVERNING CARRIER to get the fare filed by that carrier.
     * - base: xs:string
     * - pattern: [0-9A-Z]{2,3}
     * - use: required
     * @var string
     */
    public $AirlineCode;
    /**
     * Constructor method for GoverningCarrierOverrideType
     * @uses GoverningCarrierOverrideType::setAirlineCode()
     * @param string $airlineCode
     */
    public function __construct($airlineCode = null)
    {
        $this
            ->setAirlineCode($airlineCode);
    }
    /**
     * Get AirlineCode value
     * @return string
     */
    public function getAirlineCode()
    {
        return $this->AirlineCode;
    }
    /**
     * Set AirlineCode value
     * @param string $airlineCode
     * @return \SabreSoap\StructType\GoverningCarrierOverrideType
     */
    public function setAirlineCode($airlineCode = null)
    {
        $this->AirlineCode = $airlineCode;
        return $this;
    }
}
