<?php

namespace SabreSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OriginDestinationOptions StructType
 * Meta information extracted from the WSDL
 * - documentation: A collection of OriginDestinationOption | Indicates which flights are covered by this ticket
 * @subpackage Structs
 */
class OriginDestinationOptions extends AbstractStructBase
{
    /**
     * The OriginDestinationOption
     * Meta information extracted from the WSDL
     * - documentation: A container for flight segments.
     * - maxOccurs: 99
     * @var \SabreSoap\StructType\OriginDestinationOption[]
     */
    public $OriginDestinationOption;
    /**
     * Constructor method for OriginDestinationOptions
     * @uses OriginDestinationOptions::setOriginDestinationOption()
     * @param \SabreSoap\StructType\OriginDestinationOption[] $originDestinationOption
     */
    public function __construct(array $originDestinationOption = array())
    {
        $this
            ->setOriginDestinationOption($originDestinationOption);
    }
    /**
     * Get OriginDestinationOption value
     * @return \SabreSoap\StructType\OriginDestinationOption[]|null
     */
    public function getOriginDestinationOption()
    {
        return $this->OriginDestinationOption;
    }
    /**
     * Set OriginDestinationOption value
     * @param \SabreSoap\StructType\OriginDestinationOption[] $originDestinationOption
     * @return \SabreSoap\StructType\OriginDestinationOptions
     */
    public function setOriginDestinationOption(array $originDestinationOption = array())
    {
        $this->OriginDestinationOption = $originDestinationOption;
        return $this;
    }
    /**
     * Add item to OriginDestinationOption value
     * @throws \InvalidArgumentException
     * @param \SabreSoap\StructType\OriginDestinationOption $item
     * @return \SabreSoap\StructType\OriginDestinationOptions
     */
    public function addToOriginDestinationOption(\SabreSoap\StructType\OriginDestinationOption $item)
    {
        $this->OriginDestinationOption[] = $item;
        return $this;
    }
}
