<?php

namespace SabreSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PromoRedemption StructType
 * Meta information extracted from the WSDL
 * - documentation: Populated if "Coupon Redemption" rule has been hit. This had been developed for Travelocity but never used.
 * @subpackage Structs
 */
class PromoRedemption extends AbstractStructBase
{
    /**
     * The PromoID
     * @var string
     */
    public $PromoID;
    /**
     * The Eligible
     * @var bool
     */
    public $Eligible;
    /**
     * The ContentID
     * @var string
     */
    public $ContentID;
    /**
     * Constructor method for PromoRedemption
     * @uses PromoRedemption::setPromoID()
     * @uses PromoRedemption::setEligible()
     * @uses PromoRedemption::setContentID()
     * @param string $promoID
     * @param bool $eligible
     * @param string $contentID
     */
    public function __construct($promoID = null, $eligible = null, $contentID = null)
    {
        $this
            ->setPromoID($promoID)
            ->setEligible($eligible)
            ->setContentID($contentID);
    }
    /**
     * Get PromoID value
     * @return string|null
     */
    public function getPromoID()
    {
        return $this->PromoID;
    }
    /**
     * Set PromoID value
     * @param string $promoID
     * @return \SabreSoap\StructType\PromoRedemption
     */
    public function setPromoID($promoID = null)
    {
        $this->PromoID = $promoID;
        return $this;
    }
    /**
     * Get Eligible value
     * @return bool|null
     */
    public function getEligible()
    {
        return $this->Eligible;
    }
    /**
     * Set Eligible value
     * @param bool $eligible
     * @return \SabreSoap\StructType\PromoRedemption
     */
    public function setEligible($eligible = null)
    {
        $this->Eligible = $eligible;
        return $this;
    }
    /**
     * Get ContentID value
     * @return string|null
     */
    public function getContentID()
    {
        return $this->ContentID;
    }
    /**
     * Set ContentID value
     * @param string $contentID
     * @return \SabreSoap\StructType\PromoRedemption
     */
    public function setContentID($contentID = null)
    {
        $this->ContentID = $contentID;
        return $this;
    }
}
