<?php

namespace SabreSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoutingDefinitionType StructType
 * Meta information extracted from the WSDL
 * - documentation: Definition of a routing
 * @subpackage Structs
 */
class RoutingDefinitionType extends AbstractStructBase
{
    /**
     * The RoutingLeg
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \SabreSoap\StructType\RoutingLegType[]
     */
    public $RoutingLeg;
    /**
     * The AddWildcards
     * Meta information extracted from the WSDL
     * - documentation: If true, wildcards will be automatically inserted between each two leg (RoutingLeg) elements. Will be set to 'false' if not present.
     * - use: optional
     * @var bool
     */
    public $AddWildcards;
    /**
     * Constructor method for RoutingDefinitionType
     * @uses RoutingDefinitionType::setRoutingLeg()
     * @uses RoutingDefinitionType::setAddWildcards()
     * @param \SabreSoap\StructType\RoutingLegType[] $routingLeg
     * @param bool $addWildcards
     */
    public function __construct(array $routingLeg = array(), $addWildcards = null)
    {
        $this
            ->setRoutingLeg($routingLeg)
            ->setAddWildcards($addWildcards);
    }
    /**
     * Get RoutingLeg value
     * @return \SabreSoap\StructType\RoutingLegType[]|null
     */
    public function getRoutingLeg()
    {
        return $this->RoutingLeg;
    }
    /**
     * Set RoutingLeg value
     * @param \SabreSoap\StructType\RoutingLegType[] $routingLeg
     * @return \SabreSoap\StructType\RoutingDefinitionType
     */
    public function setRoutingLeg(array $routingLeg = array())
    {
        $this->RoutingLeg = $routingLeg;
        return $this;
    }
    /**
     * Add item to RoutingLeg value
     * @throws \InvalidArgumentException
     * @param \SabreSoap\StructType\RoutingLegType $item
     * @return \SabreSoap\StructType\RoutingDefinitionType
     */
    public function addToRoutingLeg(\SabreSoap\StructType\RoutingLegType $item)
    {
        $this->RoutingLeg[] = $item;
        return $this;
    }
    /**
     * Get AddWildcards value
     * @return bool|null
     */
    public function getAddWildcards()
    {
        return $this->AddWildcards;
    }
    /**
     * Set AddWildcards value
     * @param bool $addWildcards
     * @return \SabreSoap\StructType\RoutingDefinitionType
     */
    public function setAddWildcards($addWildcards = null)
    {
        $this->AddWildcards = $addWildcards;
        return $this;
    }
}
