<?php

namespace SabreSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TimeOfDayRange StructType
 * @subpackage Structs
 */
class TimeOfDayRange extends AbstractStructBase
{
    /**
     * The Begin
     * Meta information extracted from the WSDL
     * - documentation: Beginning of the TimeOfDayRange in HHMM format. | IntelliSell Time Window Boundary type in format HHMM.
     * - base: xs:string
     * - pattern: ([0-1][0-9]|2[0-3])[0-5][0-9]
     * - use: required
     * @var string
     */
    public $Begin;
    /**
     * The End
     * Meta information extracted from the WSDL
     * - documentation: End of the TimeOfDayRange in HHMM format. | IntelliSell Time Window Boundary type in format HHMM.
     * - base: xs:string
     * - pattern: ([0-1][0-9]|2[0-3])[0-5][0-9]
     * - use: required
     * @var string
     */
    public $End;
    /**
     * The Percentage
     * Meta information extracted from the WSDL
     * - documentation: Defines how many percent options should be in the TimeOfDayRange.
     * - base: xs:unsignedShort
     * - maxInclusive: 100
     * - minInclusive: 0
     * - use: required
     * @var int
     */
    public $Percentage;
    /**
     * Constructor method for TimeOfDayRange
     * @uses TimeOfDayRange::setBegin()
     * @uses TimeOfDayRange::setEnd()
     * @uses TimeOfDayRange::setPercentage()
     * @param string $begin
     * @param string $end
     * @param int $percentage
     */
    public function __construct($begin = null, $end = null, $percentage = null)
    {
        $this
            ->setBegin($begin)
            ->setEnd($end)
            ->setPercentage($percentage);
    }
    /**
     * Get Begin value
     * @return string
     */
    public function getBegin()
    {
        return $this->Begin;
    }
    /**
     * Set Begin value
     * @param string $begin
     * @return \SabreSoap\StructType\TimeOfDayRange
     */
    public function setBegin($begin = null)
    {
        $this->Begin = $begin;
        return $this;
    }
    /**
     * Get End value
     * @return string
     */
    public function getEnd()
    {
        return $this->End;
    }
    /**
     * Set End value
     * @param string $end
     * @return \SabreSoap\StructType\TimeOfDayRange
     */
    public function setEnd($end = null)
    {
        $this->End = $end;
        return $this;
    }
    /**
     * Get Percentage value
     * @return int
     */
    public function getPercentage()
    {
        return $this->Percentage;
    }
    /**
     * Set Percentage value
     * @param int $percentage
     * @return \SabreSoap\StructType\TimeOfDayRange
     */
    public function setPercentage($percentage = null)
    {
        $this->Percentage = $percentage;
        return $this;
    }
}
